unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, xfer_32, StdCtrls;

type
  TForm1 = class(TForm)
    Xfer1: TXfer;
    MainMenu1: TMainMenu;
    Port1: TMenuItem;
    BaudRate1: TMenuItem;
    NOPORT1: TMenuItem;
    COM11: TMenuItem;
    COM21: TMenuItem;
    COM31: TMenuItem;
    COM41: TMenuItem;
    N24001: TMenuItem;
    N48001: TMenuItem;
    N96001: TMenuItem;
    N144001: TMenuItem;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Memo2: TMemo;
    Button1: TButton;
    GroupBox1: TGroupBox;
    lblSent: TLabel;
    lblReceived: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Xfer1Receive(Sender: TObject; count: Word);
    procedure Xfer1Transmit(Sender: TObject; count: Word);
    procedure NOPORT1Click(Sender: TObject);
    procedure N24001Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Xfer1Error(Sender: TObject; err: string);
  private
    procedure UpdateMenu;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.UpdateMenu;
begin
  Port1.Items[Ord(Xfer1.Port)].Checked := True;
  BaudRate1.Items[Ord(Xfer1.BaudRate) - Ord(___2400)].Checked := True;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  data: string;
begin
  Memo2.Clear;
  data := Memo1.Text;
  Xfer1.Write(data, Length(data));
  Memo1.Clear;
end;

procedure TForm1.Xfer1Receive(Sender: TObject; count: Word);
var
  data: string;
begin
  Xfer1.Read(data, count);
  Memo2.Text := data;
  lblReceived.Caption := IntToStr(Length(data)) + ' bytes received';
end;

procedure TForm1.Xfer1Transmit(Sender: TObject; count: Word);
begin
  lblSent.Caption := IntToStr(count) + ' bytes sent';
end;

procedure TForm1.NOPORT1Click(Sender: TObject);
var
  p: TPort;
begin
  p := NO_PORT;
  Inc(p, (Sender as TMenuItem).Tag);
  Xfer1.Port := p;
  UpdateMenu;
end;

procedure TForm1.N24001Click(Sender: TObject);
var
  b: TBaudRate;
begin
  b := ___2400;
  Inc(b, (Sender as TMenuItem).Tag);
  Xfer1.BaudRate := b;
  UpdateMenu;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  lblSent.Caption := '';
  lblReceived.Caption := '';
  UpdateMenu;
end;

procedure TForm1.Xfer1Error(Sender: TObject; err: string);
begin
  ShowMessage(err);
end;

end.
